package cl.skyvortex.rememberit;

import java.util.Calendar;
import java.util.Timer;
import java.util.TimerTask;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.media.MediaPlayer;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.os.Vibrator;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ToggleButton;

public class Remember extends Activity {
	private int width;
	private int height;
	protected ToggleButton btnAM;
	protected ToggleButton btnPM;
	protected ToggleButton btnAll;
	private Handler hand;
	private RememberApp app;
	private Vibrator v;
	private MediaPlayer mp;
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        app = (RememberApp)this.getApplication();
		v = (Vibrator) this.getSystemService(Context.VIBRATOR_SERVICE);
		mp = MediaPlayer.create(this, R.raw.water_drop);
        hand = new Handler(){
			public void handleMessage(Message msg) {
				if(app.checkTime()){
					//Codigo para la vibracion del telefono
					v.vibrate(1000);
					
					//Codigo para reproducir algun sonido
					mp.setLooping(true);
					mp.start();
					
					//Codigo para mostrar el mensaje de alerta
					AlertDialog.Builder builder = new AlertDialog.Builder(Remember.this);
					builder.setTitle("Alarma");
					builder.setMessage(app.getMessage());
					builder.setNegativeButton("Cerrar", new DialogInterface.OnClickListener(){
						public void onClick(DialogInterface dialog, int which){
							
						}
					});
					builder.show();
					
					//Detener el sonido en reproduccion
					if(mp.isPlaying())
						mp.stop();
				}
			}
		};
        this.height = this.getWindowManager().getDefaultDisplay().getHeight();
        this.width = this.getWindowManager().getDefaultDisplay().getWidth();
        setContentView(R.layout.main);
        displayItems();
    }
    
    private void displayItems(){
    	Calendar now = Calendar.getInstance();
    	String s = new String();
    	EditText day = (EditText)this.findViewById(R.id.edit_day);
    	day.setWidth(width/6);
    	if(now.get(Calendar.DAY_OF_MONTH) < 10)
    		s = "0" + Integer.toString(now.get(Calendar.DAY_OF_MONTH));
    	else
    		s = Integer.toString(now.get(Calendar.DAY_OF_MONTH));
    	day.setText(s);
    	
    	EditText month = (EditText)this.findViewById(R.id.edit_month);
    	month.setWidth(width/6);
    	if(now.get(Calendar.MONTH) < 9)
    		s = "0" + Integer.toString(now.get(Calendar.MONTH) + 1);
    	else
    		s = Integer.toString(now.get(Calendar.MONTH + 1 ));
    	month.setText(s);
    	
    	EditText year = (EditText)this.findViewById(R.id.edit_year);
    	year.setWidth(width/6 + 8);
    	if(now.get(Calendar.YEAR) < 10)
    		s = "0" + Integer.toString(now.get(Calendar.YEAR));
    	else
    		s = Integer.toString(now.get(Calendar.YEAR));
    	year.setText(s);
    	
    	EditText hour = (EditText)this.findViewById(R.id.edit_hour);
    	hour.setWidth(width/6);
    	if(now.get(Calendar.HOUR_OF_DAY) < 10)
    		s = "0" + Integer.toString(now.get(Calendar.HOUR_OF_DAY));
    	else
    		s = Integer.toString(now.get(Calendar.HOUR_OF_DAY));
    	hour.setText(s);
    	
    	EditText min = (EditText)this.findViewById(R.id.edit_minutes);
    	min.setWidth(width/6);
    	if(now.get(Calendar.MINUTE) < 10)
    		s = "0" + Integer.toString(now.get(Calendar.MINUTE));
    	else
    		s = Integer.toString(now.get(Calendar.MINUTE));
    	min.setText(s);
    	
    	btnAM = (ToggleButton)this.findViewById(R.id.btn_am);
    	btnAM.setWidth(width/3);
    	
    	btnPM = (ToggleButton)this.findViewById(R.id.btn_pm);
    	btnPM.setWidth(width/3);
    	
    	btnAll = (ToggleButton)this.findViewById(R.id.btn_complete);
    	btnAll.setWidth(width/3);
    	
    	btnAM.setOnClickListener(new OnClickListener(){
    		
			public void onClick(View arg0) {
				btnAM.setChecked(true);
    			btnPM.setChecked(false);
    			btnAll.setChecked(false);
			}
    	});
    	
    	btnPM.setOnClickListener(new OnClickListener(){
    		
			public void onClick(View arg0) {
				btnPM.setChecked(true);
    			btnAM.setChecked(false);
    			btnAll.setChecked(false);
			}
    	});

		btnAll.setOnClickListener(new OnClickListener(){
			
			public void onClick(View arg0) {
				btnAll.setChecked(true);
				btnPM.setChecked(false);
				btnAM.setChecked(false);
			}
		});
    		
    	displayNumpad();
    	TimerTask timerTask = new TimerTask(){
			public void run() {
				hand.sendEmptyMessage(0);
			}
		};
		Timer timer = new Timer();
		timer.scheduleAtFixedRate(timerTask, 0, 60000);
    }
    
    private void displayNumpad(){
    	Button one = (Button)this.findViewById(R.id.one);
    	one.setWidth(width/3);
    	one.setHeight(height/8);
    	
    	Button two = (Button)this.findViewById(R.id.two);
    	two.setWidth(width/3);
    	two.setHeight(height/8);
    	
    	Button three = (Button)this.findViewById(R.id.three);
    	three.setWidth(width/3);
    	three.setHeight(height/8);

    	Button four = (Button)this.findViewById(R.id.four);
    	four.setWidth(width/3);
    	four.setHeight(height/8);
    	
    	Button five = (Button)this.findViewById(R.id.five);
    	five.setWidth(width/3);
    	five.setHeight(height/8);
    	
    	Button six = (Button)this.findViewById(R.id.six);
    	six.setWidth(width/3);
    	six.setHeight(height/8);
    	
    	Button seven = (Button)this.findViewById(R.id.seven);
    	seven.setWidth(width/3);
    	seven.setHeight(height/8);
    	
    	Button eight = (Button)this.findViewById(R.id.eight);
    	eight.setWidth(width/3);
    	eight.setHeight(height/8);
    	
    	Button nine = (Button)this.findViewById(R.id.nine);
    	nine.setWidth(width/3);
    	nine.setHeight(height/8);
    	
    	Button zero = (Button)this.findViewById(R.id.zero);
    	zero.setWidth(width/3);
    	zero.setHeight(height/8);
    	
    	Button btnBack = (Button)this.findViewById(R.id.btn_back);
    	btnBack.setWidth(width/3);
    	btnBack.setHeight(height/8);
    	
    	Button btnOk = (Button)this.findViewById(R.id.btn_ok);
    	btnOk.setWidth(width/3);
    	btnOk.setHeight(height/8);
    }
}