package com.nfe.guardian.shared.model.resources;

import java.io.InputStream;
import java.io.StringWriter;
import java.io.Writer;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlRootElement;

/**
 * @author tiago
 * @version 1.0
 * @created 29-abr-2012 11:43:29
 */
@XmlRootElement
@XmlAccessorType(XmlAccessType.FIELD)
public class NFEGuardianError implements NFEGuardianResource {
		
	/**
	 * Codigo de erro http
	 */	
	private int httpErrorCode;	
	private String httpErrorMessage;
	/**
	 * Mesagem amigavel do erro
	 */	
	private String message;
	
	public NFEGuardianError() {}

	public NFEGuardianError(int httpErrorCode, String httpErrorMessage, String message) {
		this.httpErrorCode = httpErrorCode;
		this.httpErrorMessage = httpErrorMessage;
		this.message = message;
		
	}
	
	public NFEGuardianError(String message) {		
		this.message = message;
	}
	
	public int getHttpErrorCode() {
		return httpErrorCode;
	}
	
	public String getHttpErrorMessage() {
		return httpErrorMessage;
	}

	public String getMessage() {
		return message;
	}

	@Override
	public String toXML() throws Exception {
		return toXML(false);
	}

	@Override
	public String toXML(boolean isFragment) throws Exception {
		Writer writer = new StringWriter();
		toXML(isFragment, writer);
		return writer.toString();
	}

	@Override
	public void toXML(Writer writer) throws Exception {
		toXML(false, writer);
		
	}

	@Override
	public void toXML(boolean isFragment, Writer writer) throws Exception {
		//QS
		JAXBContext context = JAXBContext.newInstance(NFEGuardianError.class);
		Marshaller marshaller = context.createMarshaller();
		marshaller.setProperty(Marshaller.JAXB_FRAGMENT, isFragment);
		marshaller.setProperty(Marshaller.JAXB_ENCODING, "UTF-8");
		marshaller.marshal(this, writer);				
	}

	@XmlAttribute
	@Override
	public String getVersao() {		
		return "1.00";
	}
	
	@SuppressWarnings("unused")
	private static NFEGuardianError newInstance(InputStream xml) throws JAXBException {
		JAXBContext context = JAXBContext.newInstance(NFEGuardianError.class);
		return (NFEGuardianError) context.createUnmarshaller().unmarshal(xml);
	}

	@Override
	public String toString() {
		return "NFEGuardianError [httpErrorCode=" + httpErrorCode
				+ ", httpErrorMessage=" + httpErrorMessage + ", message="
				+ message + "]";
	}

}