package com.nfe.guardian.shared.model.resources;

import java.math.BigInteger;
import java.util.Set;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

import org.springframework.data.annotation.Id;
import org.springframework.data.mongodb.core.mapping.Document;
import org.springframework.security.core.GrantedAuthority;


/**
 * @author tiago
 * @version 1.0
 * @created 29-abr-2012 11:43:29
 */

@Document
@XmlRootElement
@XmlAccessorType(XmlAccessType.FIELD)
public class UserGroup implements GrantedAuthority {

	
	private static final long serialVersionUID = -4250642390184445804L;
	
	@Id
	@XmlTransient
	private BigInteger id;	
	@XmlTransient
	private Set<User> users;
	private String authority;

	public UserGroup() {}
	
	public UserGroup(String authority) {
		this.authority = authority;
	}
	
	public BigInteger getId() {
		return id;
	}
	
	public String getAuthority(){
		return authority;
	}

	public Set<User> getUsers() {
		return users;
	}	

}